VERSION 5.00
Begin VB.Form AddPJForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Add Projector"
   ClientHeight    =   3210
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5130
   BeginProperty Font 
      Name            =   "MS PGothic"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "AddPJForm.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3210
   ScaleWidth      =   5130
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3960
      TabIndex        =   13
      Top             =   600
      Width           =   975
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   3960
      TabIndex        =   12
      Top             =   120
      Width           =   975
   End
   Begin VB.ComboBox cmbModel 
      Height          =   300
      Left            =   1560
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   570
      Width           =   2175
   End
   Begin VB.TextBox txtProjectorName 
      Height          =   270
      Left            =   1560
      MaxLength       =   256
      TabIndex        =   1
      Text            =   "Projector1"
      Top             =   210
      Width           =   2175
   End
   Begin VB.Frame Frame1 
      Caption         =   "Connection"
      Height          =   2055
      Left            =   120
      TabIndex        =   4
      Top             =   960
      Width           =   3735
      Begin VB.TextBox txtPortNo 
         Height          =   270
         Left            =   1440
         MaxLength       =   5
         TabIndex        =   11
         Text            =   "23"
         Top             =   1530
         Width           =   735
      End
      Begin VB.TextBox txtIPAddress 
         Height          =   270
         Left            =   1440
         MaxLength       =   15
         TabIndex        =   9
         Text            =   "192.168.1.10"
         Top             =   1170
         Width           =   2055
      End
      Begin VB.ComboBox cmbCOMPort 
         Height          =   300
         Left            =   1440
         Style           =   2  'Dropdown List
         TabIndex        =   7
         Top             =   330
         Width           =   1215
      End
      Begin VB.OptionButton optNETWORK 
         Caption         =   "NETWORK"
         Height          =   180
         Left            =   240
         TabIndex        =   6
         Top             =   840
         Width           =   1335
      End
      Begin VB.OptionButton optRS232C 
         Caption         =   "RS-232C"
         Height          =   255
         Left            =   240
         TabIndex        =   5
         Top             =   360
         Width           =   1335
      End
      Begin VB.Label Label4 
         AutoSize        =   -1  'True
         Caption         =   "Port No"
         Height          =   180
         Left            =   480
         TabIndex        =   10
         Top             =   1560
         Width           =   585
      End
      Begin VB.Label Label3 
         AutoSize        =   -1  'True
         Caption         =   "IP Address"
         Height          =   180
         Left            =   480
         TabIndex        =   8
         Top             =   1200
         Width           =   840
      End
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Model"
      Height          =   180
      Left            =   240
      TabIndex        =   2
      Top             =   600
      Width           =   450
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Projector Name"
      Height          =   180
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   1185
   End
End
Attribute VB_Name = "AddPJForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'----------------------------------------------------------
'  Function     : cmbModel_Click
'  Return value : None
'  Argument     : None
'  Feature      : Select a model.
'  Description  : When the [Model] combobox was clicked.
'  Remarks      : None
'----------------------------------------------------------
Private Sub cmbModel_Click()
    
    Dim i As Integer
    Dim nIndex As Integer
    
    nIndex = cmbModel.ListIndex
    
    For i = 0 To ModelInfo.ModelNum - 1
        If (cmbModel.List(nIndex) = ModelInfo.Model(i).Name) Then
            If (ModelInfo.Model(i).Network = 1) Then
                txtPortNo.Text = CStr(ModelInfo.Model(i).NetworkPort)
            Else
                txtPortNo.Text = ""
            End If
            Exit For
        End If
    Next i

End Sub

'----------------------------------------------------------
'  Function     : cmdCancel_Click
'  Return value : None
'  Argument     : None
'  Feature      : AddPJForm is closed. (no save)
'  Description  : When the [Cancel] button was clicked.
'  Remarks      : None
'----------------------------------------------------------
Private Sub cmdCancel_Click()

    Unload Me
    
End Sub

'----------------------------------------------------------
'  Function     : cmdOK_Click
'  Return value : None
'  Argument     : None
'  Feature      : AddPJForm is closed. (save)
'  Description  : When the [OK] button was clicked.
'  Remarks      : None
'----------------------------------------------------------
Private Sub cmdOK_Click()

    Dim bCommand(12) As Byte
    Dim Result As Long
    Dim i As Integer
    Dim nIndex As Integer
    'Dim SockNo As Integer
    
    If (Trim(txtProjectorName.Text) = "") Then
        MsgBox "A Projector Name is not specified.", vbInformation
        Exit Sub
    End If
    If optRS232C.Value = True Then
        If (bAddPJForm = True) Then
            For i = 1 To m_nPJNum
                If (PJInfo(i).Connection.Kind = 0) Then
                    If ("COM" & CStr(PJInfo(i).Connection.Serial.PortNo) = cmbCOMPort.List(cmbCOMPort.ListIndex)) Then
                        MsgBox "COM port overlapps.", vbInformation
                        Exit Sub
                    End If
                End If
            Next i
            Timers.StatusCheckTimer.Enabled = False
            LanForm.CommandSendTimer.Enabled = False
            m_nPJNum = m_nPJNum + 1
            PJInfo(m_nPJNum).Name = txtProjectorName.Text
            PJInfo(m_nPJNum).ModelName = cmbModel.List(cmbModel.ListIndex)
            PJInfo(m_nPJNum).Connection.Kind = 0
            PJInfo(m_nPJNum).Connection.Serial.PortNo = cmbCOMPort.ListIndex + 1
            PJInfo(m_nPJNum).Connection.Serial.Settings = "19200,n,8,1"
            PJInfo(m_nPJNum).Connection.Network.IPAddress = ""
            PJInfo(m_nPJNum).Connection.Network.PortNo = ""
            PJInfo(m_nPJNum).Connection.Network.MACAddress = ""
            Unload Me
        Else
            Timers.StatusCheckTimer.Enabled = False
            LanForm.CommandSendTimer.Enabled = False
            
            nIndex = MainForm.ProjectorTree.SelectedItem.Index
            Call SelectPJIndexQueueInit(TreePJIndex(nIndex))
            
            PJInfo(TreePJIndex(nIndex)).Name = txtProjectorName.Text
            PJInfo(TreePJIndex(nIndex)).ModelName = cmbModel.List(cmbModel.ListIndex)
            PJInfo(TreePJIndex(nIndex)).Connection.Kind = 0
            PJInfo(TreePJIndex(nIndex)).Connection.Serial.PortNo = cmbCOMPort.ListIndex + 1
            PJInfo(TreePJIndex(nIndex)).Connection.Serial.Settings = "19200,n,8,1"
            PJInfo(TreePJIndex(nIndex)).Connection.Network.IPAddress = ""
            PJInfo(TreePJIndex(nIndex)).Connection.Network.PortNo = ""
            PJInfo(TreePJIndex(nIndex)).Connection.Network.MACAddress = ""
            
            Unload Me
            
            MainForm.ProjectorTree.SelectedItem.Text = PJInfo(TreePJIndex(nIndex)).Name
            Select Case MainForm.SSTab.Tab
                Case 0  'Status tab
                    MainForm.lblProjectorName(0).Caption = PJInfo(TreePJIndex(nIndex)).Name
                    MainForm.lblModel(0).Caption = PJInfo(TreePJIndex(nIndex)).ModelName
                    MainForm.lblConnection(0).Caption = "COM" & CStr(PJInfo(TreePJIndex(nIndex)).Connection.Serial.PortNo)
                Case 1  'Control tab
                    MainForm.lblProjectorName(1).Caption = PJInfo(TreePJIndex(nIndex)).Name
                    MainForm.lblModel(1).Caption = PJInfo(TreePJIndex(nIndex)).ModelName
                    MainForm.lblConnection(1).Caption = "COM" & CStr(PJInfo(TreePJIndex(nIndex)).Connection.Serial.PortNo)
                Case 2  'Schedule tab
                    MainForm.lblProjectorName(2).Caption = PJInfo(TreePJIndex(nIndex)).Name
                    MainForm.lblModel(2).Caption = PJInfo(TreePJIndex(nIndex)).ModelName
                    MainForm.lblConnection(2).Caption = "COM" & CStr(PJInfo(TreePJIndex(nIndex)).Connection.Serial.PortNo)
            End Select
        End If
    ElseIf optNETWORK.Value = True Then
        If (Trim(txtIPAddress.Text) = "") Then
            MsgBox "An IP address is not specified.", vbInformation
            Exit Sub
        End If
        If (Trim(txtPortNo.Text) = "") Then
            MsgBox "Port No is not specified.", vbInformation
            Exit Sub
        End If
        If (bAddPJForm = True) Then
            For i = 1 To m_nPJNum
                If (PJInfo(i).Connection.Kind = 1) Then
                    If (txtIPAddress.Text = PJInfo(i).Connection.Network.IPAddress And _
                        txtPortNo.Text = PJInfo(i).Connection.Network.PortNo) Then
                        MsgBox "An IP address overlaps.", vbInformation
                        Exit Sub
                    End If
                End If
            Next i
            Timers.StatusCheckTimer.Enabled = False
            LanForm.CommandSendTimer.Enabled = False
            m_nPJNum = m_nPJNum + 1
            PJInfo(m_nPJNum).Name = txtProjectorName.Text
            PJInfo(m_nPJNum).ModelName = cmbModel.List(cmbModel.ListIndex)
            PJInfo(m_nPJNum).Connection.Kind = 1
            PJInfo(m_nPJNum).Connection.Network.IPAddress = txtIPAddress.Text
            PJInfo(m_nPJNum).Connection.Network.PortNo = txtPortNo.Text
            PJInfo(m_nPJNum).Connection.Network.MACAddress = ""
            PJInfo(m_nPJNum).Connection.Serial.PortNo = 0
            PJInfo(m_nPJNum).Connection.Serial.Settings = ""
            Unload Me
            Timers.GetMACAddressTimer.Enabled = True
            
        Else
            Timers.StatusCheckTimer.Enabled = False
            LanForm.CommandSendTimer.Enabled = False
        
            nIndex = MainForm.ProjectorTree.SelectedItem.Index
            Call SelectPJIndexQueueInit(TreePJIndex(nIndex))
            
            PJInfo(TreePJIndex(nIndex)).Name = txtProjectorName.Text
            PJInfo(TreePJIndex(nIndex)).ModelName = cmbModel.List(cmbModel.ListIndex)
            PJInfo(TreePJIndex(nIndex)).Connection.Kind = 1
            PJInfo(TreePJIndex(nIndex)).Connection.Network.IPAddress = txtIPAddress.Text
            PJInfo(TreePJIndex(nIndex)).Connection.Network.PortNo = txtPortNo.Text
            PJInfo(TreePJIndex(nIndex)).Connection.Network.MACAddress = ""
        
            Unload Me
        
            Timers.GetMACAddressTimer.Enabled = True
            
            MainForm.ProjectorTree.SelectedItem.Text = PJInfo(TreePJIndex(nIndex)).Name
            Select Case MainForm.SSTab.Tab
                Case 0  'Status tab
                    MainForm.lblProjectorName(0).Caption = PJInfo(TreePJIndex(nIndex)).Name
                    MainForm.lblModel(0).Caption = PJInfo(TreePJIndex(nIndex)).ModelName
                    MainForm.lblConnection(0).Caption = PJInfo(TreePJIndex(nIndex)).Connection.Network.IPAddress
                    If (PJInfo(TreePJIndex(nIndex)).Connection.Network.MACAddress <> "") Then
                        MainForm.lblConnection(0).Caption = MainForm.lblConnection(0).Caption & " (" & PJInfo(TreePJIndex(nIndex)).Connection.Network.MACAddress & ")"
                    End If
                Case 1  'Control tab
                    MainForm.lblProjectorName(1).Caption = PJInfo(TreePJIndex(nIndex)).Name
                    MainForm.lblModel(1).Caption = PJInfo(TreePJIndex(nIndex)).ModelName
                    MainForm.lblConnection(1).Caption = PJInfo(TreePJIndex(nIndex)).Connection.Network.IPAddress
                    If (PJInfo(TreePJIndex(nIndex)).Connection.Network.MACAddress <> "") Then
                        MainForm.lblConnection(1).Caption = MainForm.lblConnection(1).Caption & " (" & PJInfo(TreePJIndex(nIndex)).Connection.Network.MACAddress & ")"
                    End If
                Case 2  'Schedule tab
                    MainForm.lblProjectorName(2).Caption = PJInfo(TreePJIndex(nIndex)).Name
                    MainForm.lblModel(2).Caption = PJInfo(TreePJIndex(nIndex)).ModelName
                    MainForm.lblConnection(2).Caption = PJInfo(TreePJIndex(nIndex)).Connection.Network.IPAddress
                    If (PJInfo(TreePJIndex(nIndex)).Connection.Network.MACAddress <> "") Then
                        MainForm.lblConnection(2).Caption = MainForm.lblConnection(2).Caption & " (" & PJInfo(TreePJIndex(nIndex)).Connection.Network.MACAddress & ")"
                    End If
            End Select
        End If
    End If
    
    Dim szParentKey As String
    Dim nodX As Node
    Dim bFlg As Boolean
    Dim j As Integer
    
    If bAddPJForm = True Then
        szParentKey = MainForm.ProjectorTree.SelectedItem.Key
'2004.11.12 add-start
        For i = 0 To MAX_PJ
            bFlg = False
            For j = 1 To MainForm.ProjectorTree.Nodes.Count
                If (Left$(MainForm.ProjectorTree.Nodes(j).Key, 1) = "p") Then
                    If (MainForm.ProjectorTree.Nodes(j).Key = "p" & CStr(i)) Then
                        bFlg = True
                        Exit For
                    End If
                End If
            Next j
            If (bFlg = False) Then
                Set nodX = MainForm.ProjectorTree.Nodes.Add(szParentKey, tvwChild, "p" & CStr(i), PJInfo(m_nPJNum).Name, 3)
                nodX.EnsureVisible
                TreePJIndex(nodX.Index) = m_nPJNum
                Exit For
            End If
        Next i
'2004.11.12 add-end
'2004.11.12 delete-start
'        Set nodX = MainForm.ProjectorTree.Nodes.Add(szParentKey, tvwChild, "p" & CStr(PjKeyNo), PJInfo(m_nPJNum).Name, 3)
'        PjKeyNo = PjKeyNo + 1
'        nodX.EnsureVisible
'        TreePJIndex(nodX.Index) = m_nPJNum
'2004.11.12 delete-end
    End If

    Call SaveTreeData '(False, "")
    Call DataSave
    
    StartTimerTime = 0
    Timers.StatusCheckTimer.Interval = 10
    Timers.StatusCheckTimer.Enabled = True
    LanForm.CommandSendTimer.Enabled = True

End Sub

'----------------------------------------------------------
'  Function     : Form_Load
'  Return value : None
'  Argument     : None
'  Feature      : AddPJForm is loaded.
'  Description  : Initialize of AddPJForm.
'  Remarks      : None
'----------------------------------------------------------
Private Sub Form_Load()

    Dim i As Integer
    Dim nIndex As Integer
    Dim szKey As String
    Dim lRet As Long
    Dim szName As String * 255
    Dim szClass As String * 255
    Dim dwNameSize As Long
    Dim dwClassSize As Long
    Dim szModelName As String
    Dim hKey As Long
    Dim dwDisposition As Long
    Dim LastWriteTime As FILETIME
    Dim nCount As Integer
    
    Call SetFormPosition(Me)
    
    For i = 1 To 256
        cmbCOMPort.AddItem "COM" & Trim(str$(i))
    Next i
    
    For i = 1 To ModelInfo.ModelNum
        cmbModel.AddItem ModelInfo.Model(i).Name
    Next i

    If (bAddPJForm = True) Then
        Me.Caption = "Add Projector"
        txtProjectorName.Text = ""
        If cmbModel.ListCount > 0 Then
            cmbModel.ListIndex = 0
        Else
            cmbModel.ListIndex = -1
        End If
        optRS232C.Value = True
        optNETWORK.Value = False
        cmbCOMPort.ListIndex = 0
        txtIPAddress.Text = ""
        If (ModelInfo.ModelNum > 0 And ModelInfo.Model(1).Network = 1) Then
            txtPortNo.Text = CStr(ModelInfo.Model(1).NetworkPort)
        Else
            txtPortNo.Text = ""
        End If
    Else
        nIndex = MainForm.ProjectorTree.SelectedItem.Index
        Me.Caption = "Edit Projector"
        txtProjectorName.Text = PJInfo(TreePJIndex(nIndex)).Name
        txtProjectorName.SelStart = Len(txtProjectorName.Text)
        cmbModel.ListIndex = -1
        nCount = cmbModel.ListCount
        For i = 0 To nCount - 1
            If cmbModel.List(i) = PJInfo(TreePJIndex(nIndex)).ModelName Then
                cmbModel.ListIndex = i
                Exit For
            End If
        Next i
        If PJInfo(TreePJIndex(nIndex)).Connection.Kind = 0 Then 'RS-232C
            optRS232C.Value = True
            optNETWORK.Value = False
        Else                                                    'NETWORK
            optRS232C.Value = False
            optNETWORK.Value = True
        End If
        If (PJInfo(TreePJIndex(nIndex)).Connection.Serial.PortNo > 0) Then
            For i = 0 To cmbCOMPort.ListCount - 1
                If (cmbCOMPort.List(i) = "COM" & CStr(PJInfo(TreePJIndex(nIndex)).Connection.Serial.PortNo)) Then
                    cmbCOMPort.ListIndex = i
                    Exit For
                End If
            Next i
        Else
            cmbCOMPort.ListIndex = 0
        End If
        txtIPAddress.Text = PJInfo(TreePJIndex(nIndex)).Connection.Network.IPAddress
        txtPortNo.Text = PJInfo(TreePJIndex(nIndex)).Connection.Network.PortNo
    End If

End Sub

