VERSION 5.00
Begin VB.Form MailAddrForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Mail Address Setting"
   ClientHeight    =   1545
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4725
   BeginProperty Font 
      Name            =   "MS PGothic"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "MailAddrForm.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1545
   ScaleWidth      =   4725
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   2640
      TabIndex        =   6
      Top             =   1080
      Width           =   1095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   960
      TabIndex        =   5
      Top             =   1080
      Width           =   1080
   End
   Begin VB.OptionButton optBCC 
      Caption         =   "BCC"
      Height          =   180
      Left            =   3120
      TabIndex        =   4
      Top             =   600
      Width           =   975
   End
   Begin VB.OptionButton optCC 
      Caption         =   "CC"
      Height          =   180
      Left            =   2160
      TabIndex        =   3
      Top             =   600
      Width           =   975
   End
   Begin VB.OptionButton optTO 
      Caption         =   "TO"
      Height          =   180
      Left            =   1200
      TabIndex        =   2
      Top             =   600
      Width           =   975
   End
   Begin VB.TextBox txtAddress 
      Height          =   270
      Left            =   1200
      TabIndex        =   1
      Top             =   180
      Width           =   3375
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Mail Address"
      Height          =   180
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   1005
   End
End
Attribute VB_Name = "MailAddrForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'----------------------------------------------------------
'  Function     : cmdCancel_Click
'  Return value : None
'  Argument     : None
'  Feature      : MailAddrForm is closed. (no save)
'  Description  : When the [Cancel] button was clicked.
'  Remarks      : None
'----------------------------------------------------------
Private Sub cmdCancel_Click()

    Unload Me
    MailForm.MailAddrList.SetFocus

End Sub

'----------------------------------------------------------
'  Function     : cmdOK_Click
'  Return value : None
'  Argument     : None
'  Feature      : MailAddrForm is closed. (save)
'  Description  : When the [OK] button was clicked.
'  Remarks      : None
'----------------------------------------------------------
Private Sub cmdOK_Click()

    If (Trim(txtAddress.Text) = "") Then
        MsgBox "An address is not specified.", vbInformation
        Exit Sub
    End If
    
    Dim i As Integer
    For i = 1 To MailForm.MailAddrList.ListItems.Count
        If (bAddressEdit = False And txtAddress.Text = MailForm.MailAddrList.ListItems(i).Text) Then
           MsgBox "An address overlaps.", vbInformation
           Exit Sub
        End If
    Next i
    
    Dim itmX As ListItem
    Dim nNum As Integer
    If (bAddressEdit = False) Then
        If (optTO.Value = True) Then
            Set itmX = MailForm.MailAddrList.ListItems.Add(, , txtAddress.Text)
            itmX.SubItems(1) = "TO"
        ElseIf (optCC.Value = True) Then
            Set itmX = MailForm.MailAddrList.ListItems.Add(, , txtAddress.Text)
            itmX.SubItems(1) = "CC"
        ElseIf (optBCC.Value = True) Then
            Set itmX = MailForm.MailAddrList.ListItems.Add(, , txtAddress.Text)
            itmX.SubItems(1) = "BCC"
        End If
        For i = 1 To MailForm.MailAddrList.ListItems.Count
            If (i = MailForm.MailAddrList.ListItems.Count) Then
                MailForm.MailAddrList.ListItems(i).Selected = True
            Else
                MailForm.MailAddrList.ListItems(i).Selected = False
            End If
        Next i
        itmX.Selected = True
        itmX.EnsureVisible
    Else
        If (optTO.Value = True) Then
            MailForm.MailAddrList.ListItems(SelectAddressIndex).Text = txtAddress.Text
            MailForm.MailAddrList.ListItems(SelectAddressIndex).SubItems(1) = "TO"
        ElseIf (optCC.Value = True) Then
            MailForm.MailAddrList.ListItems(SelectAddressIndex).Text = txtAddress.Text
            MailForm.MailAddrList.ListItems(SelectAddressIndex).SubItems(1) = "CC"
        ElseIf (optBCC.Value = True) Then
            MailForm.MailAddrList.ListItems(SelectAddressIndex).Text = txtAddress.Text
            MailForm.MailAddrList.ListItems(SelectAddressIndex).SubItems(1) = "BCC"
        End If
        MailForm.MailAddrList.ListItems(SelectAddressIndex).Selected = True
        MailForm.MailAddrList.ListItems(SelectAddressIndex).EnsureVisible
    End If
    Call MailAddrButtonUpdate
    
    Unload Me

End Sub

'----------------------------------------------------------
'  Function     : Form_Load
'  Return value : None
'  Argument     : None
'  Feature      : MailAddrForm is loaded.
'  Description  : Initialize of MailAddrForm.
'  Remarks      : None
'----------------------------------------------------------
Private Sub Form_Load()

    Call SetFormPosition(Me)
    
    If (bAddressEdit = False) Then  'add
        txtAddress.Text = ""
        optTO.Value = True
        optCC.Value = False
        optBCC.Value = False
    Else                            'edit
        Dim str As String, strsub As String
        str = MailForm.MailAddrList.ListItems(SelectAddressIndex).Text
        txtAddress.Text = str
        strsub = MailForm.MailAddrList.ListItems(SelectAddressIndex).SubItems(1)
        Select Case strsub
            Case "TO"
                optTO.Value = True
                optCC.Value = False
                optBCC.Value = False
            Case "CC"
                optTO.Value = False
                optCC.Value = True
                optBCC.Value = False
            Case "BCC"
                optTO.Value = False
                optCC.Value = False
                optBCC.Value = True
            Case Else
                optTO.Value = True
                optCC.Value = False
                optBCC.Value = False
        End Select
    End If

End Sub
