VERSION 5.00
Begin VB.Form MailTextForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Message Setting"
   ClientHeight    =   945
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   BeginProperty Font 
      Name            =   "MS PGothic"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "MailTextForm.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   945
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3600
      TabIndex        =   2
      Top             =   480
      Width           =   855
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   2640
      TabIndex        =   1
      Top             =   480
      Width           =   855
   End
   Begin VB.TextBox txtComment 
      Height          =   270
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4335
   End
End
Attribute VB_Name = "MailTextForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'----------------------------------------------------------
'  Function     : cmdCancel_Click
'  Return value : None
'  Argument     : None
'  Feature      :
'  Description  :
'  Remarks      :
'----------------------------------------------------------
Private Sub cmdCancel_Click()

    Unload Me

End Sub

'----------------------------------------------------------
'  Function     : cmdOK_Click
'  Return value : None
'  Argument     : None
'  Feature      :
'  Description  :
'  Remarks      :
'----------------------------------------------------------
Private Sub cmdOK_Click()

    Dim szKey As String
    Dim lRet As Long
    Dim hKey As Long
    
    szKey = "SOFTWARE\HITACHI\PJMan3\MailSetting"
    
    Select Case ErrKindFlag
        Case ERROR_COVERERROR
            MailInfo.ErrorAlarm.CoverError.SendText = MailTextForm.txtComment.Text
            lRet = RegOpenKeyEx(HKEY_CURRENT_USER, szKey, 0, KEY_ALL_ACCESS, hKey)
            If lRet = ERROR_SUCCESS Then
                If (Len(MailInfo.ErrorAlarm.CoverError.SendText) > 0) Then
                    lRet = RegSetValueEx(hKey, "CoverErrorText", 0, REG_SZ, MailInfo.ErrorAlarm.CoverError.SendText, Len(MailInfo.ErrorAlarm.CoverError.SendText) + 1)
                End If
                lRet = RegCloseKey(hKey)
            End If
        Case ERROR_FANERROR
            MailInfo.ErrorAlarm.FanError.SendText = MailTextForm.txtComment.Text
            lRet = RegOpenKeyEx(HKEY_CURRENT_USER, szKey, 0, KEY_ALL_ACCESS, hKey)
            If lRet = ERROR_SUCCESS Then
                If (Len(MailInfo.ErrorAlarm.FanError.SendText) > 0) Then
                    lRet = RegSetValueEx(hKey, "FanErrorText", 0, REG_SZ, MailInfo.ErrorAlarm.FanError.SendText, Len(MailInfo.ErrorAlarm.FanError.SendText) + 1)
                End If
                lRet = RegCloseKey(hKey)
            End If
        Case ERROR_LAMPERROR
            MailInfo.ErrorAlarm.LampError.SendText = MailTextForm.txtComment.Text
            lRet = RegOpenKeyEx(HKEY_CURRENT_USER, szKey, 0, KEY_ALL_ACCESS, hKey)
            If lRet = ERROR_SUCCESS Then
                If (Len(MailInfo.ErrorAlarm.LampError.SendText) > 0) Then
                    lRet = RegSetValueEx(hKey, "LampErrorText", 0, REG_SZ, MailInfo.ErrorAlarm.LampError.SendText, Len(MailInfo.ErrorAlarm.LampError.SendText) + 1)
                End If
                lRet = RegCloseKey(hKey)
            End If
        Case ERROR_TEMPERROR
            MailInfo.ErrorAlarm.TempError.SendText = MailTextForm.txtComment.Text
            lRet = RegOpenKeyEx(HKEY_CURRENT_USER, szKey, 0, KEY_ALL_ACCESS, hKey)
            If lRet = ERROR_SUCCESS Then
                If (Len(MailInfo.ErrorAlarm.TempError.SendText) > 0) Then
                    lRet = RegSetValueEx(hKey, "TempErrorText", 0, REG_SZ, MailInfo.ErrorAlarm.TempError.SendText, Len(MailInfo.ErrorAlarm.TempError.SendText) + 1)
                End If
                lRet = RegCloseKey(hKey)
            End If
        Case ERROR_AIRFLOWERROR
            MailInfo.ErrorAlarm.AirFlowError.SendText = MailTextForm.txtComment.Text
            lRet = RegOpenKeyEx(HKEY_CURRENT_USER, szKey, 0, KEY_ALL_ACCESS, hKey)
            If lRet = ERROR_SUCCESS Then
                If (Len(MailInfo.ErrorAlarm.AirFlowError.SendText) > 0) Then
                    lRet = RegSetValueEx(hKey, "AirFlowErrorText", 0, REG_SZ, MailInfo.ErrorAlarm.AirFlowError.SendText, Len(MailInfo.ErrorAlarm.AirFlowError.SendText) + 1)
                End If
                lRet = RegCloseKey(hKey)
            End If
        Case ERROR_LAMPTIMEOVER
            MailInfo.ErrorAlarm.LampTimeOver.SendText = MailTextForm.txtComment.Text
            lRet = RegOpenKeyEx(HKEY_CURRENT_USER, szKey, 0, KEY_ALL_ACCESS, hKey)
            If lRet = ERROR_SUCCESS Then
                If (Len(MailInfo.ErrorAlarm.LampTimeOver.SendText) > 0) Then
                    lRet = RegSetValueEx(hKey, "LampTimeOverText", 0, REG_SZ, MailInfo.ErrorAlarm.LampTimeOver.SendText, Len(MailInfo.ErrorAlarm.LampTimeOver.SendText) + 1)
                End If
                lRet = RegCloseKey(hKey)
            End If
        Case ERROR_COOLERROR
            MailInfo.ErrorAlarm.CoolError.SendText = MailTextForm.txtComment.Text
            lRet = RegOpenKeyEx(HKEY_CURRENT_USER, szKey, 0, KEY_ALL_ACCESS, hKey)
            If lRet = ERROR_SUCCESS Then
                If (Len(MailInfo.ErrorAlarm.CoolError.SendText) > 0) Then
                    lRet = RegSetValueEx(hKey, "CoolErrorText", 0, REG_SZ, MailInfo.ErrorAlarm.CoolError.SendText, Len(MailInfo.ErrorAlarm.CoolError.SendText) + 1)
                End If
                lRet = RegCloseKey(hKey)
            End If
        Case ERROR_FILTERERROR
            MailInfo.ErrorAlarm.FilterError.SendText = MailTextForm.txtComment.Text
            lRet = RegOpenKeyEx(HKEY_CURRENT_USER, szKey, 0, KEY_ALL_ACCESS, hKey)
            If lRet = ERROR_SUCCESS Then
                If (Len(MailInfo.ErrorAlarm.FilterError.SendText) > 0) Then
                    lRet = RegSetValueEx(hKey, "FilterErrorText", 0, REG_SZ, MailInfo.ErrorAlarm.FilterError.SendText, Len(MailInfo.ErrorAlarm.FilterError.SendText) + 1)
                End If
                lRet = RegCloseKey(hKey)
            End If
        Case ERROR_OTHERERROR
            MailInfo.ErrorAlarm.OtherError.SendText = MailTextForm.txtComment.Text
            lRet = RegOpenKeyEx(HKEY_CURRENT_USER, szKey, 0, KEY_ALL_ACCESS, hKey)
            If lRet = ERROR_SUCCESS Then
                If (Len(MailInfo.ErrorAlarm.OtherError.SendText) > 0) Then
                    lRet = RegSetValueEx(hKey, "OtherErrorText", 0, REG_SZ, MailInfo.ErrorAlarm.OtherError.SendText, Len(MailInfo.ErrorAlarm.OtherError.SendText) + 1)
                End If
                lRet = RegCloseKey(hKey)
            End If
        Case ERROR_DISCONNECT
            MailInfo.ErrorAlarm.Disconnect.SendText = MailTextForm.txtComment.Text
            lRet = RegOpenKeyEx(HKEY_CURRENT_USER, szKey, 0, KEY_ALL_ACCESS, hKey)
            If lRet = ERROR_SUCCESS Then
                If (Len(MailInfo.ErrorAlarm.Disconnect.SendText) > 0) Then
                    lRet = RegSetValueEx(hKey, "DisconnectText", 0, REG_SZ, MailInfo.ErrorAlarm.Disconnect.SendText, Len(MailInfo.ErrorAlarm.Disconnect.SendText) + 1)
                End If
                lRet = RegCloseKey(hKey)
            End If
    End Select

    Unload Me

End Sub

'----------------------------------------------------------
'  Function     : Form_Load
'  Return value : None
'  Argument     : None
'  Feature      :
'  Description  :
'  Remarks      :
'----------------------------------------------------------
Private Sub Form_Load()

    Call SetFormPosition(Me)
    
    Select Case ErrKindFlag
        Case ERROR_COVERERROR
            MailTextForm.txtComment.Text = MailInfo.ErrorAlarm.CoverError.SendText
        Case ERROR_FANERROR
            MailTextForm.txtComment.Text = MailInfo.ErrorAlarm.FanError.SendText
        Case ERROR_LAMPERROR
            MailTextForm.txtComment.Text = MailInfo.ErrorAlarm.LampError.SendText
        Case ERROR_TEMPERROR
            MailTextForm.txtComment.Text = MailInfo.ErrorAlarm.TempError.SendText
        Case ERROR_AIRFLOWERROR
            MailTextForm.txtComment.Text = MailInfo.ErrorAlarm.AirFlowError.SendText
        Case ERROR_LAMPTIMEOVER
            MailTextForm.txtComment.Text = MailInfo.ErrorAlarm.LampTimeOver.SendText
        Case ERROR_COOLERROR
            MailTextForm.txtComment.Text = MailInfo.ErrorAlarm.CoolError.SendText
        Case ERROR_FILTERERROR
            MailTextForm.txtComment.Text = MailInfo.ErrorAlarm.FilterError.SendText
        Case ERROR_OTHERERROR
            MailTextForm.txtComment.Text = MailInfo.ErrorAlarm.OtherError.SendText
        Case ERROR_DISCONNECT
            MailTextForm.txtComment.Text = MailInfo.ErrorAlarm.Disconnect.SendText
        Case Else
            Exit Sub
    End Select
    
    MailTextForm.txtComment.SelStart = Len(MailTextForm.txtComment.Text)

End Sub
