VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Timers 
   Caption         =   "Timers"
   ClientHeight    =   1530
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3645
   LinkTopic       =   "Form1"
   ScaleHeight     =   1530
   ScaleWidth      =   3645
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer PingTimer 
      Interval        =   10
      Left            =   2400
      Top             =   0
   End
   Begin VB.Timer GetMACAddressTimer 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   1920
      Top             =   0
   End
   Begin VB.Timer TimeTimer 
      Interval        =   10
      Left            =   1440
      Top             =   0
   End
   Begin VB.Timer ScheduleTimer 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   960
      Top             =   0
   End
   Begin VB.Timer MailSendTimer 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   480
      Top             =   0
   End
   Begin VB.Timer StatusCheckTimer 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   0
      Top             =   0
   End
   Begin MSComctlLib.ListView PingList 
      Height          =   975
      Left            =   480
      TabIndex        =   0
      Top             =   600
      Width           =   3135
      _ExtentX        =   5530
      _ExtentY        =   1720
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      HideColumnHeaders=   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS PGothic"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   0
   End
End
Attribute VB_Name = "Timers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'----------------------------------------------------------
'  Function     : GetMACAddressTimer_Timer
'  Return value : None
'  Argument     : None
'  Feature      :
'  Description  :
'  Remarks      :
'----------------------------------------------------------
Private Sub GetMACAddressTimer_Timer()

    GetMACAddressTimer.Enabled = False
    bMACAddrGetting = True
    
    Dim i As Integer
    
    For i = 1 To m_nPJNum
        If (PJInfo(i).Connection.Kind = 1) Then
            If (PJInfo(i).Connection.Network.MACAddress = "") Then
                Call GetMACAddress(i)
            End If
        End If
    Next i
    bMACAddrGetting = False

End Sub

'----------------------------------------------------------
'  Function     : MailSendTimer_Timer
'  Return value : None
'  Argument     : None
'  Feature      :
'  Description  :
'  Remarks      :
'----------------------------------------------------------
Private Sub MailSendTimer_Timer()

    Dim Ret As Long
    Dim QueueData As String
    Dim szTo As String
    Dim SendData As String, LogData As String
    Dim SendSuccess As Boolean
    Dim tmp As String
    Dim PJIndexTmp As Integer

    If MailSendRetryCount <> 0 Then
        If (DateDiff("n", MailSendLastRetryTime, Now) < 5) Then
            Exit Sub
        End If
    End If

    MailSendTimer.Enabled = False
    
    MailSending = True
    
    szTo = GetSendAddress
    If szTo = "" Then
        Call LogFileWrite("MailSend Error!!:An address isn't specified.")
        MailSendRetryCount = 0
        MailSendTimer.Enabled = False
        MailSending = False
        Exit Sub
    End If
    
    If (ErrorQueueEmptyCheck() = False) Then
        Do
            SendData = ""
            LogData = ""
            QueueData = ErrorQueue(ErrQueRP)
            'Time
            tmp = CutParam(";", QueueData, 1)
            SendData = SendData & "Time:" & tmp & vbCrLf
            LogData = LogData & "Time:" & tmp & ","
            'PJIndex
            PJIndexTmp = CInt(CutParam(";", QueueData, 2))
            'Projector Name
            SendData = SendData & "Projector Name:" & PJInfo(PJIndexTmp).Name & vbCrLf
            LogData = LogData & "Projector Name:" & PJInfo(PJIndexTmp).Name & ","
            'Model
            SendData = SendData & "Model:" & PJInfo(PJIndexTmp).ModelName & vbCrLf
            LogData = LogData & "Model:" & PJInfo(PJIndexTmp).ModelName & ","
            
            Select Case PJInfo(PJIndexTmp).Connection.Kind
                Case 0  'Serial
                    'PortNo
                    SendData = SendData & "Connection:" & "COM" & CStr(PJInfo(PJIndexTmp).Connection.Serial.PortNo) & vbCrLf
                    LogData = LogData & "Connection:" & "COM" & CStr(PJInfo(PJIndexTmp).Connection.Serial.PortNo) & ","
                Case 1  'Network
                    'IP Address
                    SendData = SendData & "Connection:" & PJInfo(PJIndexTmp).Connection.Network.IPAddress
                    LogData = LogData & "Connection:" & PJInfo(PJIndexTmp).Connection.Network.IPAddress
                    'MAC Address
                    If (PJInfo(PJIndexTmp).Connection.Network.MACAddress <> "") Then
                        SendData = SendData & " (" & PJInfo(PJIndexTmp).Connection.Network.MACAddress & ")" & vbCrLf
                        LogData = LogData & " (" & PJInfo(PJIndexTmp).Connection.Network.MACAddress & "),"
                    Else
                        SendData = SendData & vbCrLf
                        LogData = LogData & ","
                    End If
            End Select
            
            'Message
            tmp = CutParam(";", QueueData, 3)
            SendData = SendData & "Message:" & tmp & vbCrLf
            LogData = LogData & "Message:" & tmp
            'Log Write
            Call MailLogFileWrite(LogData)
            'Send Mail
            Ret = PJMSEND_SendMail(MailInfo.SMTPServer, szTo, MailInfo.FromAddress, MailInfo.Subject, SendData, MailInfo.FilePath)
            If (Ret = 0) Then
                Call MailLogFileWrite("Mail Send Error!!")
                SendSuccess = False
                Exit Do
            Else
                Call MailLogFileWrite("Mail Send Success")
                SendSuccess = True
                ErrQueRP = ErrQueRP + 1
                If ErrQueRP > MAX_ERR_QUE Then
                    ErrQueRP = 1
                End If
                If (ErrQueWP = ErrQueRP) Then
                    Exit Do
                End If
            End If
        Loop
        
        If SendSuccess = True Then
            MailSendRetryCount = 0
            MailSendTimer.Enabled = False
            MailSending = False
        Else
            If (MailSendRetryCount >= 3) Then
                MailSendRetryCount = 0
                MailSendTimer.Enabled = False
                MailSending = False
            Else
                MailSendLastRetryTime = Now
                MailSendRetryCount = MailSendRetryCount + 1
                MailSendTimer.Enabled = True
                MailSending = False
            End If
        End If
    Else
        MailSendRetryCount = 0
        MailSendTimer.Enabled = False
        MailSending = False
    End If

End Sub

'----------------------------------------------------------
'  Function     : PingTimer_Timer
'  Return value : None
'  Argument     : None
'  Feature      :
'  Description  :
'  Remarks      :
'----------------------------------------------------------
Private Sub PingTimer_Timer()

    Dim nIndex As Integer
    Dim Res As Boolean
    Dim tmp As String
    
    PingTimer.Enabled = False
    
    If (PingList.ListItems.Count <> 0) Then
        nIndex = Val(PingList.ListItems(1).Text)
        If (PJInfo(nIndex).Connection.Network.IPAddress <> "") Then
            Res = VbPing(PJInfo(nIndex).Connection.Network.IPAddress)
            If (Res = True) Then
                PJInfo(nIndex).Status.Disconnect = False
            Else
                If (PJInfo(nIndex).Status.Disconnect = False) Then
                    If (MailInfo.SendFlag = True And MailInfo.ErrorAlarm.SendFlag = True And _
                        MailInfo.ErrorAlarm.Disconnect.SendFlag = True) Then
'##### 2004.12.16 #####
                        'tmp = Format(Now, "yyyy/mm/dd hh:nn:ss")
                        tmp = GetDateTimeString(Now)
'##### 2004.12.16 #####
                        tmp = tmp & ";" & CStr(nIndex)
                        tmp = tmp & ";" & MailInfo.ErrorAlarm.Disconnect.SendText
                        Call SetErrorQueue(tmp)
                        If (MailSending = False And Timers.MailSendTimer.Enabled = False) Then
                            MailSendRetryCount = 0
                            Timers.MailSendTimer.Enabled = True
                        End If
                    End If
                    Call LogFileWrite("TCP-Disconnected(" & CStr(nIndex) & ")")
                End If
                PJInfo(nIndex).Status.Disconnect = True
                Dim State As Integer
                State = CheckMainFormState
                Select Case State
                    Case PROJECTOR_STATUS
                        Call SetProjectorStatusTab
                    Case GROUP_STATUS
                        Call ShowGroupStatusList
                End Select
            End If
        End If
        PingList.ListItems.Remove (1)
    End If
    
    PingTimer.Enabled = True

End Sub

'----------------------------------------------------------
'  Function     : ScheduleTimer_Timer
'  Return value : None
'  Argument     : None
'  Feature      :
'  Description  :
'  Remarks      :
'----------------------------------------------------------
Private Sub ScheduleTimer_Timer()

    Dim szDate As String, szTime As String
    
'##### 2004.12.16 #####
    'szDate = Format(Now, "MM/DD/YYYY")
    szDate = GetDateString(Now)
'##### 2004.12.16 #####
    If (LastDate <> CDate(szDate)) Then
        Call ScheduleSelect
        LastDate = CDate(szDate)
        Exit Sub
    End If

'##### 2005.02.03 #####
'##### 2004.12.16 #####
'    'szTime = Format(Now, "HH:mm")
'    szTime = GetTimeString(Now)
''##### 2004.12.16 #####
    szTime = Format(Now, "HH:mm")
'##### 2005.02.03 #####
    If (LastTime = CDate(szTime)) Then
        Exit Sub
    End If
    
    LastTime = CDate(szTime)
    
    Dim i As Integer, j As Integer, k As Integer
    Dim szBuffer As String * 64
    Dim szScheduleFile As String
    Dim Ret As Long
    Dim Result As Long
    Dim szCommand As String
    Dim FirstIndex As Integer, LastIndex As Integer
    Dim InputParam As Integer
    Dim tmp1 As String, tmp2 As String
    
    For i = 0 To ScheduleCount - 1
        Select Case Left$(ScheduleInfo(i).Key, 1)
            Case "g"    'Group schedule
                FirstIndex = 0: LastIndex = 0
                FirstIndex = MainForm.ProjectorTree.Nodes(ScheduleInfo(i).Index).Child.FirstSibling.Index
                LastIndex = MainForm.ProjectorTree.Nodes(ScheduleInfo(i).Index).Child.LastSibling.Index
                If Not (FirstIndex = 0 And LastIndex = 0) Then
                    For j = FirstIndex To LastIndex
                            If (MainForm.ProjectorTree.Nodes(j).Parent.Key = ScheduleInfo(i).Key) Then
                            szScheduleFile = App.Path & "\Schedule\" & ScheduleInfo(i).Name & ".sch"
                            Ret = GetPrivateProfileString(ScheduleInfo(i).Text, szTime, "", szBuffer, 64, szScheduleFile)
                            If (Ret <> 0) Then
                                szCommand = Left$(szBuffer, Ret)
                                Select Case szCommand
                                    Case "Power OFF"
                                        Call SetQueue(TreePJIndex(j), POWER_0)
                                    Case "Power ON"
                                        Call SetQueue(TreePJIndex(j), POWER_1)
                                    Case Else
                                End Select
                                Debug.Print szCommand
                            End If
                        End If
                    Next j
                End If
            
            Case "p"    'Projector schedule
                szScheduleFile = App.Path & "\Schedule\" & ScheduleInfo(i).Name & ".sch"
                Ret = GetPrivateProfileString(ScheduleInfo(i).Text, szTime, "", szBuffer, 64, szScheduleFile)
                If (Ret <> 0) Then
                    szCommand = Left$(szBuffer, Ret)
                    Select Case szCommand
                        Case "Power OFF"
                            Call SetQueue(TreePJIndex(ScheduleInfo(i).Index), POWER_0)
                        Case "Power ON"
                            Call SetQueue(TreePJIndex(ScheduleInfo(i).Index), POWER_1)
                        Case Else
                            If (Left(szCommand, 5) = "Input") Then
                                For j = 1 To ModelInfo.ModelNum
                                    If (ModelInfo.Model(j).Name = PJInfo(TreePJIndex(ScheduleInfo(i).Index)).ModelName) Then
                                        For k = 1 To ModelInfo.Model(j).InputNum
                                            tmp1 = CutParam(";", ModelInfo.Model(j).InputDetails(k), 1)
                                            tmp2 = CutParam(";", ModelInfo.Model(j).InputDetails(k), 2)
                                            If (Mid(szCommand, 7) = tmp2) Then
                                                InputParam = Val(tmp1)
                                                Exit For
                                            End If
                                        Next k
                                    End If
                                    Exit For
                                Next j
                                Select Case InputParam
                                    Case 0
                                        Call SetQueue(TreePJIndex(ScheduleInfo(i).Index), INPUT_0)
                                    Case 1
                                        Call SetQueue(TreePJIndex(ScheduleInfo(i).Index), INPUT_1)
                                    Case 2
                                        Call SetQueue(TreePJIndex(ScheduleInfo(i).Index), INPUT_2)
                                    Case 3
                                        Call SetQueue(TreePJIndex(ScheduleInfo(i).Index), INPUT_3)
                                    Case 4
                                        Call SetQueue(TreePJIndex(ScheduleInfo(i).Index), INPUT_4)
                                    Case 5
                                        Call SetQueue(TreePJIndex(ScheduleInfo(i).Index), INPUT_5)
                                    '##### 2005.01.21 add #####
                                    Case 6
                                        Call SetQueue(TreePJIndex(ScheduleInfo(i).Index), INPUT_6)
                                    '##### 2005.01.21 add #####
                                End Select
                            End If
                    End Select
                    Debug.Print szCommand
                End If
        End Select
    Next i

End Sub

'----------------------------------------------------------
'  Function     : StatusCheckTimer_Timer
'  Return value : None
'  Argument     : None
'  Feature      :
'  Description  :
'  Remarks      :
'----------------------------------------------------------
Private Sub StatusCheckTimer_Timer()

    Dim i As Integer
    Dim Result As Long
    Dim bCommand(12) As Byte
    
    If (DateDiff("s", StartTimerTime, Now) < StatusCheckInterval) Then
        Exit Sub
    End If
    
    StatusCheckTimer.Enabled = False
    
    For i = 1 To m_nPJNum
        Call SetQueue(i, POWER_GET)
        Call SetQueue(i, INPUT_GET)
        Call SetQueue(i, ERROR_GET)
        Call SetQueue(i, LAMPTIME_GET)
        Call SetQueue(i, FILTERTIME_GET)
    Next i
    
    StartTimerTime = Now
    StatusCheckTimer.Interval = 1000
    StatusCheckTimer.Enabled = True

End Sub

'----------------------------------------------------------
'  Function     : TimeTimer_Timer
'  Return value : None
'  Argument     : None
'  Feature      :
'  Description  :
'  Remarks      :
'----------------------------------------------------------
Private Sub TimeTimer_Timer()

    Dim szDate As String, szTime As String
    
    TimeTimer.Enabled = False
    
'##### 2004.12.16 #####
    Dim szData As String * 255
    Dim dwDataSize As Long
    Dim lpSystemTime As SYSTEMTIME
    Dim nRet As Integer, nDataSize As Integer
    Dim lngLocaleInfoType As Long
    Dim lngLocaleInfoSize As Long
    Dim bytLocaleInfo() As Byte
    Dim lngWin32apiResultCode As Long
    
    GetLocalTime lpSystemTime
    
    nDataSize = GetDateFormat(lngLocaleID, DATE_SHORTDATE, lpSystemTime, vbNullString, ByVal vbNullString, 0)
    ReDim bytLocaleInfo(nDataSize - 1)
    nRet = GetDateFormat(lngLocaleID, DATE_SHORTDATE, lpSystemTime, vbNullString, bytLocaleInfo(0), nDataSize)
    szDate = StrConv(bytLocaleInfo(), vbUnicode)
    
    nDataSize = GetTimeFormat(lngLocaleID, TIME_NOSECONDS, lpSystemTime, vbNullString, ByVal vbNullString, 0)
    ReDim bytLocaleInfo(nDataSize - 1)
    nRet = GetTimeFormat(lngLocaleID, TIME_NOSECONDS, lpSystemTime, vbNullString, bytLocaleInfo(0), nDataSize)
    szTime = StrConv(bytLocaleInfo(), vbUnicode)
    
    If (dtLastDate <> CDate(szDate)) Then
        MainForm.lblToday.Caption = "Today : " & szDate
        dtLastDate = CDate(szDate)
    End If
    If (dtLastTime <> CDate(szTime)) Then
        MainForm.lblNowTime.Caption = szTime
        dtLastTime = CDate(szTime)
    End If
'##### 2004.12.16 #####
    
    TimeTimer.Enabled = True

End Sub
