VERSION 5.00
Begin VB.Form AddGroupForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Add Group"
   ClientHeight    =   1230
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3750
   BeginProperty Font 
      Name            =   "MS PGothic"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "AddGroupForm.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1230
   ScaleWidth      =   3750
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   2108
      TabIndex        =   3
      Top             =   720
      Width           =   975
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   668
      TabIndex        =   2
      Top             =   720
      Width           =   975
   End
   Begin VB.TextBox txtGroupName 
      Height          =   270
      Left            =   1560
      TabIndex        =   1
      Text            =   "Text1"
      Top             =   210
      Width           =   1695
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Group Name"
      Height          =   180
      Left            =   360
      TabIndex        =   0
      Top             =   240
      Width           =   945
   End
End
Attribute VB_Name = "AddGroupForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'----------------------------------------------------------
'  Function     : cmdCancel_Click
'  Return value : None
'  Argument     : None
'  Feature      : AddGroup dialogue is closed. (no save)
'  Description  : When the [Cancel] button was clicked.
'  Remarks      : None
'----------------------------------------------------------
Private Sub cmdCancel_Click()

    Unload Me
    
End Sub

'----------------------------------------------------------
'  Function     : cmdOK_Click
'  Return value : None
'  Argument     : None
'  Feature      : AddGroup dialogue is closed. (save)
'  Description  : When the [OK] button was clicked.
'  Remarks      : None
'----------------------------------------------------------
Private Sub cmdOK_Click()

    Dim nCount As Integer
    Dim i As Integer
    Dim szGroupName As String
    Dim szParentKey As String
    Dim nodX As Node

    If (Trim(txtGroupName.Text) = "") Then
        MsgBox "A Group Name is not sepcified.", vbInformation
        Exit Sub
    End If
    
    nCount = MainForm.ProjectorTree.Nodes.Count
    For i = 1 To nCount
        If (Left$(MainForm.ProjectorTree.Nodes(i).Key, 1) = "g") Then
            If (MainForm.ProjectorTree.Nodes(i).Text = txtGroupName.Text) Then
                If (bAddGroupForm = True) Then
                    MsgBox "A Group Name overlaps.", vbExclamation
                    Exit Sub
                Else
                    If (i <> MainForm.ProjectorTree.SelectedItem.Index) Then
                        MsgBox "A Group Name overlaps.", vbExclamation
                        Exit Sub
                    End If
                End If
            End If
        End If
    Next i
    
    szGroupName = txtGroupName.Text
    
    Unload Me
    
    Dim bFlg As Boolean
    Dim j As Integer
    If (bAddGroupForm = True) Then
        szParentKey = MainForm.ProjectorTree.SelectedItem.Key
'2004.11.12 add-start
        For i = 0 To MAX_GROUP
            bFlg = False
            For j = 1 To MainForm.ProjectorTree.Nodes.Count
                If (Left$(MainForm.ProjectorTree.Nodes(j).Key, 1) = "g") Then
                    If (MainForm.ProjectorTree.Nodes(j).Key = "g" & CStr(i)) Then
                        bFlg = True
                        Exit For
                    End If
                End If
            Next j
            If (bFlg = False) Then
                Set nodX = MainForm.ProjectorTree.Nodes.Add(szParentKey, tvwChild, "g" & CStr(i), szGroupName, 2)
                nodX.EnsureVisible
                Exit For
            End If
        Next i
'2004.11.12 add-end
'2004.11.12 delete-start
'        Set nodX = MainForm.ProjectorTree.Nodes.Add(szParentKey, tvwChild, "g" & CStr(GrKeyNo), szGroupName, 2)
'        GrKeyNo = GrKeyNo + 1
'        nodX.EnsureVisible
'2004.11.12 delete-end
    Else
        MainForm.ProjectorTree.SelectedItem.Text = szGroupName
    End If
    
    Call SaveTreeData '(False, "")

End Sub

'----------------------------------------------------------
'  Function     : Form_Load
'  Return value : None
'  Argument     : None
'  Feature      : AddGroupForm is loaded.
'  Description  : Initialize of AddGroupForm.
'  Remarks      : None
'----------------------------------------------------------
Private Sub Form_Load()

    Call SetFormPosition(Me)

    If (bAddGroupForm = True) Then
        Me.Caption = "Add Group"
        txtGroupName.Text = ""
    Else
        Me.Caption = "Edit Group"
        txtGroupName.Text = MainForm.ProjectorTree.SelectedItem.Text
        txtGroupName.SelStart = Len(MainForm.ProjectorTree.SelectedItem.Text)
    End If

End Sub
